require 'json'

class DataCalc
  attr_accessor :length, :output, :input

  def initialize(input)
    @input = JSON.parse(input)
    @length = @input.length
    @output = nil
  end

  # What: Gets the sum of a column
  # Input: Column to add up
  # Output: Sum for column
  def sum(col)
    total = 0
    (0..@length-1).each do |l|
      total += (@input[l])[col].to_i
    end
    return total
  end

  # What: Gets list entries that include all values of arguments passed
  # Input: Variable number of arrays with field name and value 
  # Output: Parsed JSON of entries that match all input arrays
  def match(*matchnames)
    savefile = "[]"
    matchnames.each do |match|
      tmpfile = Array.new
      (0..@length-1).each do |l|
        if match[1] == (@input[l])[match[0]]
          tmpfile << @input[l]
          savefile = tmpfile.to_json
        end
      end
      @input = JSON.parse(savefile)
      @length = @input.length
    end
    @output = @input
  end

  # What: Sorts in numerical order
  # Input: Attribute to sort by
  # Output: Sorted JSON
  def sortnum(sattr)
    @input.sort_by {|e| e[sattr].to_i}.to_json
  end

  # What: Sorts in alphabetical order
  # Input: Attribute to sort by
  # Output: Sorted JSON
  def sortalpha(sattr)
    @input.sort_by {|e| e[sattr]}.to_json
  end

  # What: Get average of a column
  # Input: Column to get average of
  # Output: Average
  def mean(col)
    mean = sum(col).to_f / @length.to_f
  end
end

